#include "hmg.ch"

#command COMPRESS [ FILES ] <afiles> ;
		TO <zipfile>  ;
		BLOCK <block> ;
		[ RESULT [ TO ] <lSuccess> ] ;
		[ LEVEL <level> ] ;
		[ <ovr: OVERWRITE> ] ;
		[ PASSWORD <password> ] ;
		[ <srp: STOREPATH> ] ;
		[ FILEPROGRESS <fileblock> ] ;
	=> ;
	[ <lSuccess> := ] hb_ZipFile( <zipfile> , <afiles> , <level> , <block> , <.ovr.> , <password> , <.srp.> , , <fileblock> )

#command UNCOMPRESS [ FILE ] <zipfile> ;
		[ EXTRACTPATH <extractpath> ] ;
		[ RESULT [ TO ] <lSuccess> ] ;
		[ BLOCK <block> ] ;
		[ <createdir: CREATEDIR> ] ;
		[ PASSWORD <password> ] ;
		[ <dummy1: FILEMASK, FILEARRAY> <mask> ] ;
		[ FILEPROGRESS <fileblock> ] ;
	=> ;
	[ <lSuccess> := ] hb_UnZipFile( <zipfile> , <block> , <.createdir.> , <password> , <extractpath> , <mask> , <fileblock> )

*--------------------------------------------------------*
FUNCTION  MAIL_CONFIG()  
*--------------------------------------------------------*
Declare Window Form_1
*-----------------------------------------------------------------------------------------*
*                 Courtesy of  DaNiElMaXiMiLiAnO   --> CDOsys sending email               *                       
*                        http://hmgforum.com/viewtopic.php?f=24&t=3473                    *
*-----------------------------------------------------------------------------------------* 
*--------------------------------  Day Date and Time RICHEDITBOX -------------------------*
  PUBLIC   aChecZIP := .F.   ,   TransZIP := 0   
  PUBLIC   cFileQ , cConeQ , cRazaQ , altery ,   cFileNameY   
  PRIVATE  ProximaDatex := DATE() 
  PRIVATE  ProxiNumDiax := SUBSTR(DTOC(ProximaDatex),1,2)
  PRIVATE  ProxiNomDiax := HB_OEMTOANSI( CDOW(ProximaDatex))  
  PRIVATE  ProximoMesx  := CMONTH ( ProximaDatex )    
  PRIVATE  ProximoAnox  := SUBSTR(DTOC(ProximaDatex),7,4)
  PRIVATE  ProximoHorax := TIME()               &&  Optional 00:00   ->  LEFT( TIME(), 5 ) 
  PRIVATE  FechaQ , rNum  , rCev,  lSuccess   
*-----------------------------------------------------------------------------------------*
  rNum := "0000000000"   
*-----------------------------------------------------------------------------------------*
         
            DEFINE WINDOW Main      ;
                   AT       0 , 0   ; 
                   WIDTH     500    ;
		   HEIGHT    460    ;  
		   TITLE SPACE(2)+'Config - E-Mails' ;   
		   ICON "Logo"    ;
		   CHILD  NOSYSMENU  NOMINIMIZE NOMAXIMIZE   

                   ON KEY ESCAPE ACTION ( Form_1.Check_3.Value:= .F. , xButVisible_SI(), Main.Release ) 

            DrawWindowBoxRaised( "Main" , 10, 10, 411, 473 )
                 
            DEFINE CONTEXT MENU
                   MENUITEM 'Cut'    ACTION send_CUT()           Image "Resource\Cut.jpg"
                   MENUITEM 'Copy'   ACTION send_COPY()          Image "Resource\Copy.jpg"
                   MENUITEM 'Paste'  ACTION send_paste()         Image "Resource\Paste.jpg"
                   MENUITEM 'Delete' Action _PushKey ( 32 )      Image "Resource\Delete.jpg"   
                   SEPARATOR
                   MENUITEM 'Select all' ACTION send_selectall() Image "Resource\Select_all.jpg"
            END MENU  

                   DEFINE TIMER Timer_08 INTERVAL 100 ;
                          ACTION { || thisWindow.Row := 145 , thisWindow.Col := 425 }     

*---------------------------------------------------------------------------------------------------------*
  XcFrom    := ""       
  XcPass    := ""
  XcTo      := "" 
  XcsunTo   := "" 
  Xcontent  := "" 
*---------------------------------------------------------------------------------------------------------*
  IF FILE('M_Config.mem') 
     RESTORE FROM M_Config.mem ADDITIVE
     XcFrom     :=  HB_DECRYPT( maMXcRaz0 , cSenha )
     XcPass     :=  HB_DECRYPT( maMXcRaz1 , cSenha )
     XcTo       :=  HB_DECRYPT( maMXcRaz2 , cSenha )
     XcsunTo    :=  HB_DECRYPT( maMXcRaz3 , cSenha )
     Xcontent   :=  HB_DECRYPT( maMXcRaz4 , cSenha )                  
  ENDIF
*---------------------------------------------------------------------------------------------------------*

    @ 021,127 LABEL Label_00R VALUE "Only valid e-Mail Sender @gmail.com " WIDTH 300 HEIGHT 024 FONT "Arial" SIZE 11 BOLD ITALIC    

    MiFrame( 056,050,380,205,"Frame_01Q","e_Mail Config",{ 007 ,002 , 204}, { 240,240,240 }  )  

    @ 073,065 LABEL Label_01R VALUE "Sender Address:" WIDTH 125 HEIGHT 024 FONT "Arial" SIZE 9 BOLD ITALIC    
   
    DEFINE TEXTBOX cFrom 
        ROW    071
        COL    193  
        WIDTH  225 
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Sender Address"
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        PASSWORD .F.                  
        BACKCOLOR { 180,200,255 }      
        FONTCOLOR Nil
        INPUTMASK Nil
        MAXLENGTH 35             
        FORMAT Nil
        VALUE XcFrom
        LOWERCASE .T.  
        UPPERCASE .F.       
    END TEXTBOX
   
    @ 098,065 LABEL Label_03R VALUE "Sender Password :"  WIDTH 125 HEIGHT 024 FONT "Arial" SIZE 9 BOLD ITALIC    

    DEFINE TEXTBOX  cPass  
        ROW    096
        COL    193   
        WIDTH  225 
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Sender Password"
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        PASSWORD .T.                  
        BACKCOLOR { 180,200,255 }      
        FONTCOLOR Nil
        MAXLENGTH 35              
        FORMAT Nil
        VALUE  XcPass   
        LOWERCASE .T.  
        UPPERCASE .F.   
    END TEXTBOX

    @ 123,065 LABEL Label_04R VALUE "Receiver Address:"  WIDTH 125 HEIGHT 024 FONT "Arial" SIZE 9 BOLD ITALIC    

    DEFINE TEXTBOX  cTo  
        ROW    121
        COL    193   
        WIDTH  225  
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Receiver Address"  
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        PASSWORD .F.                  
        BACKCOLOR { 180,200,255 }      
        FONTCOLOR Nil
        MAXLENGTH 35              
        FORMAT Nil
        VALUE  XcTo  
        LOWERCASE .T. 
        UPPERCASE .F.   
    END TEXTBOX

    @ 148,065 LABEL Label_05R VALUE "Subject:"  WIDTH 125 HEIGHT 024 FONT "Arial" SIZE 9 BOLD ITALIC    

    DEFINE TEXTBOX  asunto 
        ROW    146
        COL    193   
        WIDTH  225  
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Subjet"  
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        PASSWORD .F.                  
        BACKCOLOR { 180,200,255 }      
        FONTCOLOR Nil
        MAXLENGTH 40              
        FORMAT Nil
        VALUE XcsunTo 
    END TEXTBOX

  @ 173,065 LABEL Label_06R VALUE "Notes:"  WIDTH 100 HEIGHT 024 FONT "Arial" SIZE 9 BOLD ITALIC     

*-----------------------------------------------------------------------------------------------------------------*
          
        FechaQ   := ProxiNomDiax + " ,"+SPACE(1) + ProxiNumDiax + SPACE(1) +  ProximoMesx + ;
                       SPACE(1)  + ProximoAnox   + SPACE(2) + ProximoHorax + CRLF + CRLF  

  DEFINE RICHEDITBOX  content
        ROW    171  
        COL    193   
        WIDTH  227   
        HEIGHT 079  
        VALUE  FechaQ     
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Write here the message content"
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        BACKCOLOR { 180,200,255 }      
        MAXLENGTH 500
    END RICHEDITBOX

   @ 198,065 LABEL Label_07R VALUE "Attachments:"  WIDTH 100 HEIGHT 024 FONT "Arial" SIZE 9 BOLD ITALIC     

    DEFINE  CHECKBOX Check_4
        ROW    220 
        COL    065  
        WIDTH  125 
        CAPTION SPACE(2)+'Files'+SPACE(3)+ HB_UChar(187)+SPACE(4)+'ZIP ?'           
        VALUE  .F. 
        FONTNAME "Arial"
        FONTSIZE 9
        FONTBOLD .T. 
        FONTITALIC .T.
        TOOLTIP  CRLF + SPACE(2) +'Files'+SPACE(3)+ HB_UChar(187)+SPACE(3)+'ZIP ?'+ CRLF +SPACE(15)
        ONCHANGE xTransZIP() 
    END CHECKBOX

*------------------------------------------------------------------------------------------*
*--------------------------------------------------------------------------------------------------*
  
        MiFrame( 284,050,380,51,"Frame_02Q","Selection Password",{ 007 ,002 , 204}, { 240,240,240 }  )  //{ 128,128,255} )     

         DEFINE CHECKBOX Check_1Q
	        ROW    288  
                COL    065
                WIDTH  090 
                HEIGHT 042
                CAPTION SPACE(2)+"Automatic"     
                VALUE .T.  
                FONTNAME "Arial"
                FONTSIZE 9
	        FONTBOLD .T.
	     *  BACKCOLOR {128,128,255}    
	        TRANSPARENT .F.
                TOOLTIP "PassWord"
                ONCHANGE Num_Pasword()        
         END CHECKBOX

         DEFINE TEXTBOX Text_2Q
               ROW    297 
               COL    338   
               WIDTH  082
               HEIGHT 022
               FONTNAME "Arial"
               FONTSIZE 9
               TOOLTIP ""
               ONCHANGE nPassManualy()
               ONGOTFOCUS Nil
               ONLOSTFOCUS Nil
               FONTBOLD .T.
               FONTITALIC .F.
               FONTUNDERLINE .F.
               FONTSTRIKEOUT .F.
               ONENTER Nil
               HELPID Nil
               TABSTOP .T.
               VISIBLE .T.
               READONLY .T.
               RIGHTALIGN .F.
               DISABLEDBACKCOLOR  { 218,254,218 }  
               DISABLEDFONTCOLOR  { 000,000,000 } 
               BACKCOLOR  { 218,254,218 }   
               FONTCOLOR  { 000,000,000 } 
               FORMAT  Nil
               INPUTMASK "9999999999"
               VALUE  ALLTRIM( rNum  )  
               MAXLENGTH 10                  
               UPPERCASE .F. 
               LOWERCASE .T. 
         END TEXTBOX

         DEFINE LABEL Lab_002    
                ROW    300  
		COL    164  
		WIDTH  167   
		HEIGHT 030 
		VALUE  "Password  For -> Un_Zip: "     
		FONTNAME "Arial"
		FONTSIZE 10
		TOOLTIP ""
		FONTBOLD .T.
		BACKCOLOR { 240,240,240 } 
	 END LABEL

*-------------------------------------------------------------------------------*

    DEFINE BUTTON Test_07
         ROW    357  
         COL    107
         WIDTH  115
         HEIGHT 036
         ACTION ( Save_Mail() , Main.Release )  
         CAPTION SPACE(03)-"Save"
         PICTURE "Resource\Acep.bmp"
         PICTALIGNMENT LEFT 
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         TOOLTIP  "Save Config" 
    END BUTTON
  
    DEFINE BUTTON Test_08
         ROW    357  
         COL    255
         WIDTH  115
         HEIGHT 036
         ACTION  ( Form_1.Check_3.Value:= .F. ,  xButVisible_SI() , Main.Release )
         CAPTION SPACE(07)-"Cancel"         
         PICTURE "Resource\Cancel.bmp"
         PICTALIGNMENT LEFT 
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         TOOLTIP "Cancel"
    END BUTTON
 
  END WINDOW
    
    Main.content.SetFocus
    Main.Check_1Q.Value := .F. 

    Main.Check_1Q.Enabled := .F.
    Main.Text_2Q.Enabled  := .F.
    Main.Lab_002.Enabled  := .F.  
 
    Form_1.Label_01ry.Hide  
    Form_1.Label_02ry.Hide

    Main.Center
    ACTIVATE WINDOW Main  

Return

*-------------------------------------------------------------------------------------------*
 FUNCTION   Num_Pasword()
*-------------------------------------------------------------------------------------------*

    Main.Text_2Q.ReadOnly := .T.
    Main.Check_1Q.CAPTION := SPACE(2)+"Automatic" 
 
    aChecboQ  := ( IIF(Main.Check_1Q.Value,"True","False") )
 
    IF aChecboQ = "True"  
      IF  mirgy ==  "0"
          rNum  := pQrix 
          Main.Text_2Q.Value := ALLTRIM( rNum  )  
          Main.Check_1Q.CAPTION := SPACE(2) + "Automatic" 
          Main.Text_2Q.ReadOnly := .T.
          Main.Text_2Q.Value := ALLTRIM( rNum  )   
     ELSE
         rNum  := ALLTRIM( pRova )                 
         Main.Text_2Q.Value := ALLTRIM( rNum  )  
     ENDIF
    ELSE
      rNum := "0000000000"  
      Main.Check_1Q.CAPTION := SPACE(2)+"Manually "
      Main.Text_2Q.ReadOnly := .F.
      Main.Text_2Q.Value := ALLTRIM( rNum  )  
      nPassManualy()
  ENDIF

  hb_gcAll()

RETURN NIL

*------------------------------------------------------------------------------*
Function  nPassManualy()
*------------------------------------------------------------------------------*
  rNum  :=  Main.Text_2Q.Value 

RETURN NIL

*-----------------------------------------------------------------------------------*
 Function xTransZIP()
*-----------------------------------------------------------------------------------*
 IF  aChecZIP := .T.
     aChecZIP := .F.
     aChecZIP := .T.
     TransZIP :=  1
     Main.Check_1Q.Enabled := .T.
     Main.Text_2Q.Enabled  := .T.
     Main.Lab_002.Enabled  := .T.  
     TablisKy()            
  ELSE
     aChecZIP := .F.
     TransZIP :=  0
     Main.Check_1Q.Enabled := .F.
     Main.Text_2Q.Enabled  := .F.
     Main.Lab_002.Enabled  := .F.  
  ENDIF
Return
*-----------------------------------------------------------------------------------*
 Function Save_Mail()
*-----------------------------------------------------------------------------------*
  IF  Main.cFrom.Value < " " .OR.  Main.cPass.Value < " "
      msgStop('Missing Username or Missing Password','Attention')
      Form_1.Check_3.Value := .F.
      xButVisible_SI()
      Return
  ENDIF
*-----------------------------------------------------------------------------------*
  XcFrom    :=  Main.cFrom.Value           
  XcPass    :=  Main.cPass.Value          
  XcTo      :=  Main.cTo.Value 
  XcsunTo   :=  Main.Asunto.Value           
  Xcontent  :=  Main.content.Value
  XcileZip  :=  TransZIP   
  rNum      :=  Main.Text_2Q.Value 
*-----------------------------------------------------------------------------------* 
 maMXcRaz0  :=  HB_CRYPT( XcFrom    , cSenha )
 maMXcRaz1  :=  HB_CRYPT( XcPass    , cSenha )
 maMXcRaz2  :=  HB_CRYPT( XcTo      , cSenha )
 maMXcRaz3  :=  HB_CRYPT( XcsunTo   , cSenha )
 maMXcRaz4  :=  HB_CRYPT( Xcontent  , cSenha )
 maMXcRaz5  :=  XcileZip  
 maMXcRaz6  :=  HB_CRYPT( rNum , cSenha )   
*-----------------------------------------------------------------------------------*
 SAVE TO M_Config.mem ALL LIKE  maMXcRaz*

 View_Label_MAIL()
 Form_1.Check_3.Value := .T.
 xButVisible_SI()

Return
 
*----------------------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------*

*-----------------------------------------------------------------------------------* 
  Function Send_1()
*-----------------------------------------------------------------------------------* 

  IF ! FILE('M_Config.mem') 
     msgStop( "Missing the Control Files 'M_Config.mem' ","Attention")
     Return
  ELSE
     RESTORE FROM M_Config.mem ADDITIVE
     XcFrom     :=  HB_DECRYPT( maMXcRaz0 , cSenha )
     XcPass     :=  HB_DECRYPT( maMXcRaz1 , cSenha )
     XcTo       :=  HB_DECRYPT( maMXcRaz2 , cSenha )
     XcsunTo    :=  HB_DECRYPT( maMXcRaz3 , cSenha )
     Xcontent   :=  HB_DECRYPT( maMXcRaz4 , cSenha ) 
     XcileZip   :=  maMXcRaz5                
  ENDIF

*-----------------------------------------------------------------------------------*
*--------------------------------  Optional Info -----------------------------------* 
/*
    MsgInfo(  XcFrom   + CRLF + ;
              XcPass   + CRLF + ;
              XcTo     + CRLF + ;
              XcsunTo  + CRLF + ; 
              Xcontent , 'Config e-Mail' )          */   && <- Optional
*-----------------------------------------------------------------------------------*
*-----------------------------------------------------------------------------------*
   PRIVATE oCfg, oMsg, oError , lSmtpUseSSL := .T. 
   PRIVATE cHtml
*-----------------------------------------------------------------------------------*
*--------------------------------  Optional Info -----------------------------------* 
/*
      Gmail    'smtp.gmail.com'           Port: 465  &&  Gmail Very Good!
      Outlook  'smtp-mail.outlook.com'    Port:  25 
      Yahoo    'smtp.mail.yahoo.com'      Port: 465  &&  Ports: -> 465, 587, o 25
      Yahoo    'smtp.mail.yahoo.com.ar'   Port: 465  &&  Argentina                 */

 *------------------------------ Yahoo connection error     ------------------------*
 /*    Error WINOLE/1007 No se pudo enviar el mensaje al servidor SMTP.
  *    El cdigo de error de transporte fue 0x80040217. 
  *    La respuesta del servidor fue not available (0x80040211): SEND (DOS Error -2147352567)
  *
  *    WINOLE / 1007 Error Could not send the message to the SMTP server.
 *    The error code was 0x80040217 transport.
 *    The server response was not available (0x80040211): SEND (DOS Error -2147352567)  */
*------------------------------------------------------------------------------------*

   /* Guardamos la configuracion de Servidor, Puerto, Usuario 
      We keep settings Server, Port, User                      */
	  
      oCfg := CREATEOBJECT( "CDO.Configuration" )
      WITH OBJECT oCfg:Fields
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpserver" )      :Value := ALLTRIM('smtp.gmail.com')  
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpserverport" )  :Value := 465  
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") :Value := .T.
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpusessl" )      :Value := .T.
         :Item( "http://schemas.microsoft.com/cdo/configuration/sendusername" )    :Value :=  ALLTRIM(XcFrom)    
         :Item( "http://schemas.microsoft.com/cdo/configuration/sendpassword" )    :Value :=  ALLTRIM(XcPass) 
         :Item( "http://schemas.microsoft.com/cdo/configuration/sendusing" )       :Value :=  2              
         :Update()
      END WITH

      oMsg := CREATEOBJECT ( "CDO.Message" )
      WITH OBJECT oMsg
	 :Configuration := oCfg
         :From          := ALLTRIM( XcFrom )    
         :To            := ALLTRIM( XcTo) 
         :Subject       := ALLTRIM( XcsunTo )  
         :TextBody      := ALLTRIM( Xcontent ) + "Shipping Date"+SPACE(2) +  DTOC(DATE()) + space(2)+ TIME()		  
	 
         :AddAttachment(  cFileName )                  &&  <--- a file each consignment
 	
        *	 If Main.Files.ItemCount > 0
        *    For k:=1 to Main.Files.ItemCount
        *        :AddAttachment(Main.Files.Item(k))    &&  <---- Shipping multiple files
        *    Next k
        *        Endif
		 
         :Send()
      ENDWITH
 
  *   MsgInfo ( "Your Email was sent correctly ", " Warning Message ")   &&  <----  Optional Info
       
  
   RETURN
 
*--------------------------------------------------------------------------* 
   Function Attachment_1()
*--------------------------------------------------------------------------* 
  
  IF nLogX = 6       
     cFileName :=  GetCurrentFolder()+"\Screenshot_Pdf\"+strzero(coUn,4)+".Pdf" 
  ELSE
     cFileName :=  GetCurrentFolder()+"\Screenshot\"+strzero(coUn,4)+"."+ miraS  
  ENDIF

  Return 

*--------------------------------------------------------------------------* 
  Function Send_2()        // Zip Files Yes Password & No Password
*--------------------------------------------------------------------------* 

  IF ! FILE('M_Config.mem') 
     msgStop( "Missing the Control Files 'M_Config.mem' ","Attention")
     Return
  ELSE
     RESTORE FROM M_Config.mem ADDITIVE
     XcFrom     :=  HB_DECRYPT( maMXcRaz0 , cSenha )
     XcPass     :=  HB_DECRYPT( maMXcRaz1 , cSenha )
     XcTo       :=  HB_DECRYPT( maMXcRaz2 , cSenha )
     XcsunTo    :=  HB_DECRYPT( maMXcRaz3 , cSenha )  
     Xcontent   :=  HB_DECRYPT( maMXcRaz4 , cSenha ) 
     XcileZip   :=  maMXcRaz5               
  ENDIF

*-----------------------------------------------------------------------------------*
*--------------------------------  Optional Info -----------------------------------* 
/*
    MsgInfo(  XcFrom  + CRLF + ;
              XcPass  + CRLF + ;
              XcTo    + CRLF + ;
              XcsunTo + CRLF + ; 
              Xcontent , 'Config e-Mail' )          */   && <- Optional

*-----------------------------------------------------------------------------------*
*-----------------------------------------------------------------------------------*
   PRIVATE oCfg, oMsg, oError , lSmtpUseSSL := .T. 
   PRIVATE cHtml
*-----------------------------------------------------------------------------------*
*--------------------------------  Optional Info -----------------------------------* 
/*
      Gmail    'smtp.gmail.com'           Port: 465  &&  Gmail Very Good!
      Outlook  'smtp-mail.outlook.com'    Port:  25 
      Yahoo    'smtp.mail.yahoo.com'      Port: 465  &&  Ports: -> 465, 587, o 25
      Yahoo    'smtp.mail.yahoo.com.ar'   Port: 465  &&  Argentina                 */

*------------------------------- Yahoo connection error     ------------------------*
 /*    Error WINOLE/1007 No se pudo enviar el mensaje al servidor SMTP.
  *    El cdigo de error de transporte fue 0x80040217. 
  *    La respuesta del servidor fue not available (0x80040211): SEND (DOS Error -2147352567)
  *
  *    WINOLE / 1007 Error Could not send the message to the SMTP server.
 *    The error code was 0x80040217 transport.
 *    The server response was not available (0x80040211): SEND (DOS Error -2147352567)  */
*------------------------------------------------------------------------------------*

   /* Guardamos la configuracion de Servidor, Puerto, Usuario 
      We keep settings Server, Port, User                      */
	  
      oCfg := CREATEOBJECT( "CDO.Configuration" )
      WITH OBJECT oCfg:Fields
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpserver" )      :Value := ALLTRIM('smtp.gmail.com')  
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpserverport" )  :Value := 465  
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") :Value := .T.
         :Item( "http://schemas.microsoft.com/cdo/configuration/smtpusessl" )      :Value := .T.
         :Item( "http://schemas.microsoft.com/cdo/configuration/sendusername" )    :Value :=  ALLTRIM(XcFrom)    
         :Item( "http://schemas.microsoft.com/cdo/configuration/sendpassword" )    :Value :=  ALLTRIM(XcPass) 
         :Item( "http://schemas.microsoft.com/cdo/configuration/sendusing" )       :Value :=  2              
         :Update()
      END WITH

      oMsg := CREATEOBJECT ( "CDO.Message" )
      WITH OBJECT oMsg
	 :Configuration := oCfg
         :Configuration := oCfg
         :From          := ALLTRIM( XcFrom )    
         :To            := ALLTRIM( XcTo) 
         :Subject       := ALLTRIM( XcsunTo )        
         :TextBody      := ALLTRIM( Xcontent ) + "Shipping Date"+SPACE(2) +  DTOC(DATE()) + space(2)+ TIME()	
	  
         :AddAttachment( cFileNameY )                 &&  <--- a file each consignment   TxT Password
     	 :AddAttachment( cFileNameQ )                 &&  <--- a file each consignment   Zip File
        	
        *	 If Main.Files.ItemCount > 0
        *    For k:=1 to Main.Files.ItemCount
        *        :AddAttachment(Main.Files.Item(k))    &&  <---- Shipping multiple files
        *    Next k
        *	 Endif

         :Send()

      ENDWITH
 
 *   MsgInfo ( "Your Email was sent correctly ", " Warning Message ")   &&  <----  Optional Info
*------------------------------------------  Confirma envio de e-Mail  -----------------------------------------*
     SELECT 1  
     USE Check
     LOCATE FOR ZIP_MAIL = ALLTRIM( Date_Copy )
    IF FOUND()
           REPLACE SENT WITH .T. 
    ELSE
           REPLACE SENT WITH .F. 
    ENDIF
*---------------------------------------------------------------------------------------------------------------*
 RETURN

*--------------------------------------------------------------------------* 
   Function Attachment_2()
*--------------------------------------------------------------------------* 

  PRIVATE cFolderQ := HB_CurDrive() + ":\" + Alltrim(CurDir())+"\Screenshot\"
  PRIVATE eRater ,  nFiles_Found 

  eRater       :=  (cFolderQ +"*.*")
  nFiles_Found := ADIR(eRater) 
 
  IF nFiles_Found == 10
      Create_Zip()      
 ELSE
    Return
 ENDIF

*--------------------------------------------------------------------------* 
FUNCTION  Create_Zip()         
*--------------------------------------------------------------------------* 

  IF nLogX = 6
     PRIVATE k, aFiles:=Directory("Screenshot_Pdf\*.*"), myFiles:={}
     PRIVATE Dirx
  ELSE
     PRIVATE k, aFiles:=Directory("Screenshot\*.*"), myFiles:={}
     PRIVATE Dirx
  ENDIF

   IF FILE('ZCounter.mem')
          RESTORE FROM 'ZCounter.mem' ADDITIVE 
          ZcoUn = ZcoUn + 1   
          SAVE ALL LIKE ZcoUn* TO 'ZCounter.mem' 
          RESTORE FROM 'ZCounter.mem' ADDITIVE    
   ELSE 
          RESTORE FROM 'ZCounter.mem' ADDITIVE 
       IF ZcoUn = 0
          ZcoUn = ZcoUn + 1   
          SAVE ALL LIKE ZcoUn* TO 'ZCounter.mem' 
          RESTORE FROM 'ZCounter.mem' ADDITIVE    
       ENDIF
  ENDIF
          RESTORE FROM 'ZCounter.mem' ADDITIVE    

*-----------------------------------------------------------------------------------------------------*
PRIVATE HORY      := STRZERO(ZcoUn,4)     
PRIVATE DIAX      :=ltrim(str(day(date())))+"-"+ltrim(str(month(date())))+"-"+ltrim(str(year(date())))
PRIVATE Date_Copy :="File_Backup"+"_"+alltrim(DIAX)+"-"+alltrim(HORY)+".zip"
PRIVATE FTPcFileNameQ 
*------------------------------------------------------------------------------------------------------*

  RESTORE FROM 'M_Config.mem'  ADDITIVE   
  rNum :=  HB_DECRYPT(  maMXcRaz6  , cSenha )   // Desencriptar Password
  rCev :=  HB_DECRYPT(  maMXcRaz2  , cSenha )   // Desencriptar Receiver_Mail

  DirX := GetCurrentFolder()+"\Screenshot_Zip\"          

 IF nLogX = 6
    For k:=1 to Len(aFiles)
        AADD( myFiles,"Screenshot_Pdf\"+ aFiles[k,1] )   &&  Add FileNames only
    Next k
 ELSE
    For k:=1 to Len(aFiles)
        AADD( myFiles,"Screenshot\"+ aFiles[k,1] )       && Add FileNames only
   Next k
ENDIF

 IF  rNum  <> "0000000000"

*-----------------------------------------------------------------* 
*---------------------------------------------------------------------------------------------------*
      altery := HORY    // <--- STRZERO(ZcoUn,4)
      cFileQ := "Screenshot_Zip\Soporte-"+ALLTRIM( altery) +".txt"  
      cConeQ :=  CRLF + Date_Copy + CRLF + ;
                 CRLF + SPACE(09) +"Password Number"+CRLF + ;  // 4
                 CRLF + SPACE(11) + ALLTRIM(rNUM)+SPACE(10)+CRLF+CHR(13)+CHR(10)  // 6
      cRazaQ :=  HB_CRYPT(cConeQ , cSenha )
      HB_MEMOWRIT( cFileQ , cRazaQ ,.T.)
*---------------------------------------------------------------------------------------------------*

      DirX := GetCurrentFolder()+"\Screenshot_Zip\"     
      cFileNameY  := ( DIRx + "Soporte-"+ALLTRIM( altery) +".txt")      // Attachment 
       
           COMPRESS myFiles               ;
                TO DIRx + Date_Copy       ;   
		BLOCK {|| NIL}	          ;        
		LEVEL 9                   ;
		PASSWORD ALLTRIM( rNum )  ;
		OVERWRITE                 ;
		RESULT lSuccess
   
   ELSE
       cFileNameY  := ( DIRx + "Soporte-NoPass.txt")  

          COMPRESS myFiles                ;
               TO DIRx + Date_Copy        ;        
               BLOCK {|| NIL}	          ;                          
               LEVEL 9                    ;
               OVERWRITE
  ENDIF

   CLOSE DATABASES
      SELECT 1  
      USE Check
      APPEND BLANK
      REPLACE ZIP_MAIL  WITH ALLTRIM(Date_Copy)
      REPLACE RECEIVER  WITH ALLTRIM( rCev )
   IF rNum <> "0000000000"  
      REPLACE PASS_MAIL  WITH ALLTRIM( rNum )
   ELSE
      REPLACE PASS_MAIL  WITH "NoPassMail" 
   ENDIF
      REPLACE DATE   WITH DATE()
      REPLACE TIME   WITH TIME()
 
   cFileNameQ := ( DIRx + Date_Copy) 

  Send_2()
  TablisKy()    

  SAVE ALL LIKE ZcoUn* TO 'ZCounter.mem'   
  ZcoUn = ZcoUn + 1

  RESTORE FROM 'ZCounter.mem' ADDITIVE 

      
Return Nil


*_____________________________________________________________________________________________________________________*
*_____________________________________________________________________________________________________________________*


*--------------------------------------------------------------------------* 
FUNCTION TablisKy()   
*--------------------------------------------------------------------------* 

*----------------------------- Back Files ---------------------------------*

PRIVATE cOrigin  := HB_CurDrive() + ":\" + Alltrim(CurDir())+"\Screenshot\"
PRIVATE cDestiny := HB_CurDrive() + ":\" + Alltrim(CurDir())+"\Screenshot_Back\"
PRIVATE a_Files , c_Orig , c_Dest

a_Files := DIRECTORY(cOrigin)          

FOR a=1 to LEN(a_Files) 
    c_Orig := cOrigin  + a_Files[a,1] 
    c_Dest := cDestiny + a_Files[a,1] 
    COPY FILE (c_Orig) TO (c_Dest) 
NEXT  


 IF nLogX = 6
    FileDelete("Screenshot\*.*")
    FileDelete("Screenshot_Pdf\*.*")
 ELSE
    FileDelete("Screenshot\*.*")
 ENDIF

*---------------------- Optional Counter  "0"  --------------------------*
/*   DeleteFile( ALLTRIM(cFolder) +'\'+'Counter.mem')  

   coUn = 0  
   SAVE ALL LIKE coUn* TO (ALLTRIM(cFolder) +'\'+'Counter.mem')  
       
   Form_1.Label_02.Value := ALLTRIM(STR(coUn))   */
*------------------------------------------------------------------------*

Return

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

****************************************
*     RICHEDITBOX ( Copy & Paste )     *
*   Ciro Vargas Clemow   Junio 2010    *
*   Assembly: mustalopez@gmail.com     *
****************************************
*                                      *
*     'Cut' 'Copy' 'Paste' 'Delete'    *
*                                      *
****************************************

*--------------------------------------------------------------------------------*

#pragma BEGINDUMP

#include <windows.h>

#include <winuser.h>

#include "hbapi.h"

#define VK1_A 65
#define VK1_C 67
#define VK1_V 86
#define VK1_X 88
/* select all - ctrl-a */
HB_FUNC( SEND_SELECTALL )
{
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
keybd_event(VK1_A, MapVirtualKey(VK1_A, 0), 0, 0);
keybd_event(VK1_A, MapVirtualKey(VK1_A, 0), KEYEVENTF_KEYUP, 0);
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP,
0);
}
/* copy - ctrl-c */
HB_FUNC( SEND_COPY )
{
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
keybd_event(VK1_C, MapVirtualKey(VK1_C, 0), 0, 0);
keybd_event(VK1_C, MapVirtualKey(VK1_C, 0), KEYEVENTF_KEYUP, 0);
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP,
0);
}
/* paste - ctrl-v */
HB_FUNC( SEND_PASTE )
{
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
keybd_event(VK1_V, MapVirtualKey(VK1_V, 0), 0, 0);
keybd_event(VK1_V, MapVirtualKey(VK1_V, 0), KEYEVENTF_KEYUP, 0);
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP,
0);
}
/* cut - ctrl-x */
HB_FUNC( SEND_CUT )
{
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
keybd_event(VK1_X, MapVirtualKey(VK1_X, 0), 0, 0);
keybd_event(VK1_X, MapVirtualKey(VK1_X, 0), KEYEVENTF_KEYUP, 0);
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP,
0);
}
#pragma ENDDUMP

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*








































