#include "hmg.ch"

*----------------------------------------*
*   Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*
Declare Window Form_1
Declare Window Form_2s
*------------------------------------------------------------*
Function mPrinting()
*------------------------------------------------------------*

If !IsWIndowActive (Form_2s )

  DEFINE WINDOW Form_2s       ;
      AT 0,0                  ;
      WIDTH  300              ;
      HEIGHT 220              ;  
      NOCAPTION               ;
      BACKCOLOR {209,238,238} ;
      TOPMOST                 ;
      CHILD NOSIZE            ;
      ON INIT (  CreatBasex() , Enabel_11x() )  

      ON KEY ESCAPE ACTION ( KilleBase(),  Enabel_22x() , Form_2s.Release )  

*------------------------------------------------------------*

        BoxShadow( 007, 006, 294, 215 ,"00sx" ,"00sz", 137,115,183 )
        Form_2s.Label_00sx.Enabled := .F.
        Form_2s.Label_00sz.Enabled := .F.

*------------------------------------------------------------*

     DEFINE FRAME frame_02
         ROW 021
         COL 090
         WIDTH  120
         HEIGHT 119
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         CAPTION "Printer"
         BACKCOLOR { 137,115,183 }
         FONTCOLOR Nil
         OPAQUE .T.
     END FRAME

     DEFINE LABEL  Label_Print
        ROW    038
        COL    111
        WIDTH  090
        HEIGHT 020
        VALUE "Printer List"
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP "Printer List"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 137,115,183 }
        FONTCOLOR NIL
    END LABEL

    DEFINE RADIOGROUP RadioGroup_Print
        ROW    060
        COL    111
        WIDTH  085
        HEIGHT 050
        OPTIONS {'Print Image','Print Mail','Print FTP'}
        VALUE 1
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE nil
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        SPACING 25
        BACKCOLOR { 137,115,183 }
        FONTCOLOR NIL
        READONLY Nil
        HORIZONTAL .F.
    END RADIOGROUP

*------------------------------------------------------------*
*------------------------------------------------------------*

     @ 158, 030 BUTTON But_Print   ;  
         CAPTION "A&cept"          ;
         PICTURE "Resource\ok.bmp" ;
         FONT "Arial"              ;
         SIZE 9                    ;
         BOLD                      ;
         ITALIC                    ;
         ACTION Search_Print()     ;
         TOOLTIP "Acept"           ;
         RIGHT                     ;
         WIDTH 110                 ;
         HEIGHT 40

      @ 158,160 BUTTON But_Cancel  ;
         CAPTION "C&ancel"         ;
         PICTURE "Resource\cancelx.bmp" ;
         FONT "Arial"              ;
         SIZE 9                    ;
         BOLD                      ;
         ITALIC                    ;
         ACTION  ( KilleBase(), Enabel_22x() , Form_2s.Release )  ;
         TOOLTIP "Cancel"          ;
         RIGHT                     ;
         WIDTH 110                 ;
         HEIGHT 40

  END WINDOW

     SETWINDOWCURSOR (Form_2s.But_Cancel.Handle , "Resource\SmoothHand.cur")

   CENTER WINDOW Form_2s
   ACTIVATE WINDOW Form_2s

Return Nil

ELSE
   Form_2s.Show 
   Form_2s.SetFocus
ENDIF

*-------------------------------------------------------------------------------------------* 
 FUNCTION Enabel_11x()  
*-------------------------------------------------------------------------------------------*
Form_1.test_1.Enabled  := .F.
Form_1.test_2.Enabled  := .F.
Form_1.test_3.Enabled  := .F.
Form_1.test_4.Enabled  := .F.
Form_1.test_5.Enabled  := .F.
Form_1.test_6.Enabled  := .F.
Form_1.test_7.Enabled  := .F.     // Opcional --> SETPROPERTY( "Form_1","test_7","Enabled",.F.)
Form_1.test_8.Enabled  := .F. 
Form_1.test_9.Enabled  := .F. 
Form_1.test_10.Enabled := .F. 
RETURN NIL
*-------------------------------------------------------------------------------------------* 
 FUNCTION Enabel_22x()  
*-------------------------------------------------------------------------------------------*
Form_1.test_1.Enabled  := .T.
Form_1.test_2.Enabled  := .T.
Form_1.test_3.Enabled  := .T.
Form_1.test_4.Enabled  := .T.
Form_1.test_5.Enabled  := .T.
Form_1.test_6.Enabled  := .T.
Form_1.test_7.Enabled  := .T. 
Form_1.test_8.Enabled  := .T. 
Form_1.test_9.Enabled  := .T. 
Form_1.test_10.Enabled := .T. 
RETURN NIL

*------------------------------------------------------------*
 FUNCTION CreatBasex()
*------------------------------------------------------------*
     CLOSE DATABASES
     SELECT 1  
     USE Check    
     COPY TO ("CheckM.dbf") 
     CLOSE DATABASES
     SELECT 1  
     USE Check    
     COPY TO ("CheckF.dbf") 
     CLOSE DATABASES
     SELECT 1  
     USE CheckM
  DO WHILE .NOT. EOF()    
     DELETE FOR ZIP_MAIL = Space(1)
  ENDDO 
  PACK   
     CLOSE DATABASES
     SELECT 1  
     USE CheckF
  DO WHILE .NOT. EOF()    
     DELETE FOR ZIP_FTP = Space(1)
  ENDDO 
  PACK   
  CLOSE DATABASES
Return Nil

*------------------------------------------------------------*
 FUNCTION KilleBase()
*------------------------------------------------------------*
  CLOSE DATABASES
  FileDelete("CheckM.dbf")
  FileDelete("CheckF.dbf")
Return Nil


*------------------------------------------------------------*
 Function Search_Print()
*------------------------------------------------------------*

   DO CASE

      CASE  Form_2s.RadioGroup_Print.value = 1
           ( Form_2s.Hide, Busca_Viewry_Print() )

      CASE  Form_2s.RadioGroup_Print.value = 2
           ( Enabel_22x(), Form_2s.Release, CreateReport1() , ExecuteReport('Report1',.T.))  

      CASE  Form_2s.RadioGroup_Print.value = 3
           ( Enabel_22x(), Form_2s.Release, CreateReport2() , ExecuteReport('Report2',.T.))

   ENDCASE

Return Nil


*------------------------------------------------------------*
 FUNCTION CreateReport1()
*------------------------------------------------------------*
  
     CLOSE DATABASES
     SELECT 2   
     USE CheckM
     dbgotop()
  
*-------------------------------------------------------------------*

	DEFINE REPORT Report1


        	* Report Layout ***********************************************

		BEGIN LAYOUT 
			PAPERSIZE	PRINTER_PAPER_A4
			ORIENTATION	PRINTER_ORIENT_LANDSCAPE             // <--------Horizontal       PRINTER_ORIENT_PORTRAIT ?  <----- Vertical
		END LAYOUT

		* Header Band *************************************************

		BEGIN HEADER

			BANDHEIGHT	25
			
			BEGIN TEXT
				EXPRESSION       'Listado Screenshot e_Mail'    
				ROW		010  	
				COL		113 
				WIDTH		100	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	22	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT 
			END TEXT

			BEGIN PICTURE
				VALUE	        'Resource\Maquina1.bmp'  //   Logo ?  
				ROW		012 	  
				COL		037
				WIDTH		009 	
				HEIGHT		006 
				STRETCH		.F.
			END PICTURE

                        BEGIN LINE
				FROMROW		023
				FROMCOL		010
				TOROW		023
				TOCOL		290
				PENWIDTH	0.1
				PENCOLOR	{ 0 , 0 , 0 }
			END LINE

                        BEGIN TEXT                                                                 
                                EXPRESSION      SPACE(16)+ '        Zip_Mail'+SPACE(48)+ 'RECEIVER'+SPACE(41)+'Pass_Mail' + SPACE(29)+'Date' 
                                ROW		025 	
				COL		011   
				WIDTH		250	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	 10	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT 
			END TEXT

                        BEGIN TEXT   
                                EXPRESSION      SPACE(09)+ ' Time' +SPACE(14)+'Sent'
				ROW		025 	
				COL		222 
				WIDTH		250	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	 10	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT 
			END TEXT                  
                 
                        BEGIN LINE
				FROMROW		030
				FROMCOL		010
				TOROW		030
				TOCOL		290
				PENWIDTH	0.1
				PENCOLOR	{ 0 , 0 , 0 }
			END LINE

		END HEADER

		* Detail Band *************************************************


                BEGIN DETAIL

			BANDHEIGHT	5  


                        BEGIN TEXT
				EXPRESSION	ALLTRIM( CheckM->ZIP_MAIL)                    
				ROW		011
				COL		016   
				WIDTH		175  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
                                FORMAT          'E'
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT   
			END TEXT

			BEGIN TEXT
				EXPRESSION	ALLTRIM( CheckM->RECEIVER)       
				ROW		011
				COL		085 
				WIDTH		185  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
                                FORMAT          'E'
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT   
			END TEXT
			
                        BEGIN TEXT
				EXPRESSION	ALLTRIM( CheckM->PASS_MAIL)        
				ROW		011
				COL		153 
				WIDTH		035   
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
                                FORMAT          'E'
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT
			END TEXT

			BEGIN TEXT
				EXPRESSION	DTOC( CheckM->DATE) 
				ROW		011
				COL		195  
				WIDTH		035   
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
                                FORMAT          'E'
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT
			END TEXT

                        BEGIN TEXT
				EXPRESSION	ALLTRIM( CheckM->TIME)   
				ROW		011
				COL		230 
				WIDTH		035  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT  
			END TEXT                        

                        BEGIN TEXT
				EXPRESSION	IIF(CheckM->SENT,".T.",".F.")  
				ROW		011
				COL		256 
				WIDTH		035  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT  
			END TEXT            

                       
		END DETAIL

                * Footer Band *************************************************

		BEGIN FOOTER

			BANDHEIGHT  29  

                        BEGIN LINE
				FROMROW		12
				FROMCOL		10	
				TOROW		12	
				TOCOL		290	
				PENWIDTH	0.1	
				PENCOLOR	{ 0 , 0 , 0 }	
			END LINE


			BEGIN TEXT
				EXPRESSION	'Page. No:' + Str(_PageNo)
				ROW		14  	
				COL		11	
				WIDTH		100	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT
			END TEXT

			BEGIN TEXT
				EXPRESSION	Date()
				ROW		14	
				COL		273  	
				WIDTH		30	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT  
			END TEXT

		END FOOTER



		* Summary Band ************************************************

		BEGIN SUMMARY

			BANDHEIGHT	50

			BEGIN TEXT
				EXPRESSION	'Total Records: ' +SPACE(5)+ ALLTRIM(Str(RecCount()))
				ROW		020  
				COL		020	
				WIDTH		100	
				HEIGHT		030
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT 
			END TEXT

			


		END SUMMARY

	END REPORT

Return
*------------------------------------------------------------*
 FUNCTION CreateReport2()
*------------------------------------------------------------*

     CLOSE DATABASES
     SELECT 3   
     USE CheckF
     dbgotop()
  
*-------------------------------------------------------------------*

	DEFINE REPORT Report2


        	* Report Layout ***********************************************

		BEGIN LAYOUT 
			PAPERSIZE	PRINTER_PAPER_A4
			ORIENTATION	PRINTER_ORIENT_LANDSCAPE             // <--------Horizontal       PRINTER_ORIENT_PORTRAIT ?  <----- Vertical
		END LAYOUT

		* Header Band *************************************************

		BEGIN HEADER

			BANDHEIGHT	25
			
			BEGIN TEXT
				EXPRESSION      'Listado Screenshot Ftp'     
				ROW		010  	
				COL		113 
				WIDTH		100	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	22	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT 
			END TEXT


                        BEGIN PICTURE
				VALUE	        'Resource\Maquina1.bmp'  //   Logo ?  
				ROW		012  
				COL		037
				WIDTH		009 	
				HEIGHT		006  
				STRETCH		.F.
			END PICTURE


                        BEGIN LINE
				FROMROW		023
				FROMCOL		010
				TOROW		023
				TOCOL		290
				PENWIDTH	0.1
				PENCOLOR	{ 0 , 0 , 0 }
			END LINE

                        BEGIN TEXT  
                                EXPRESSION      SPACE(16)+ '        Zip_FTP'+SPACE(50)+ 'Ip_Config'+SPACE(43)+'Pass_FTP' + SPACE(32)+'Date'                                                                
                                ROW		025 	
				COL		011   
				WIDTH		250	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	 10	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT 
			END TEXT

                        BEGIN TEXT   
                                EXPRESSION      SPACE(09)+ ' Time' +SPACE(14)+'Sent'
				ROW		025 	
				COL		222  
				WIDTH		250	
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	 10	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT 
			END TEXT                  
                 
                        BEGIN LINE
				FROMROW		030
				FROMCOL		010
				TOROW		030
				TOCOL		290
				PENWIDTH	0.1
				PENCOLOR	{ 0 , 0 , 0 }
			END LINE

		END HEADER

		* Detail Band *************************************************


                BEGIN DETAIL

			BANDHEIGHT	5  

                        BEGIN TEXT
				EXPRESSION	ALLTRIM(CheckF->ZIP_FTP)                     
				ROW		011
				COL		016   
				WIDTH		175  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
                                FORMAT          'E'
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT   
			END TEXT

			BEGIN TEXT
				EXPRESSION	ALLTRIM(CheckF->IP_CONFIG)        
				ROW		011
				COL		095 
				WIDTH		185  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
                                FORMAT          'E'
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT   
			END TEXT
			
                        BEGIN TEXT
				EXPRESSION	ALLTRIM(CheckF->PASS_FTP)       
				ROW		011
				COL		155
				WIDTH		035   
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
                                FORMAT          'E'
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT
			END TEXT

			BEGIN TEXT
				EXPRESSION	DTOC(CheckF->DATE) 
				ROW		011
				COL		200 
				WIDTH		035   
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
                                FORMAT          'E'
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT
			END TEXT

                        BEGIN TEXT
				EXPRESSION	ALLTRIM(CheckF->TIME)  
				ROW		011
				COL		230 
				WIDTH		035  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT  
			END TEXT                        

                        BEGIN TEXT
				EXPRESSION	IIF(CheckF->SENT,".T.",".F.")   
				ROW		011
				COL		256 
				WIDTH		035  
				HEIGHT		010	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT  
			END TEXT            

                       
		END DETAIL

                * Footer Band *************************************************
	        BEGIN FOOTER

                        BANDHEIGHT  29  

                        BEGIN LINE
				FROMROW		12
				FROMCOL		10	
				TOROW		12	
				TOCOL		290	
				PENWIDTH	0.1	
				PENCOLOR	{ 0 , 0 , 0 }	
			END LINE


			BEGIN TEXT
				EXPRESSION	'Page. No:' + Str(_PageNo)
				ROW		14  	
				COL		11	
				WIDTH		100	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT
			END TEXT

			BEGIN TEXT
				EXPRESSION	Date()
				ROW		14	
				COL		273  	
				WIDTH		30	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT  
			END TEXT

		END FOOTER

		* Summary Band ************************************************

		BEGIN SUMMARY

			BANDHEIGHT	50

			BEGIN TEXT
				EXPRESSION	'Total Records: ' +SPACE(5)+ ALLTRIM(Str(RecCount()))
				ROW		020  
				COL		020	
				WIDTH		100	
				HEIGHT		030
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	LEFT 
			END TEXT

			


		END SUMMARY

	END REPORT

Return

*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*









































