﻿/*

 Made By Sylvain Robert 2004-01-23
 Modified for MiniGUI by Grigory Filatov 2007-10-26
 Modified for Hmg by Mustafa López & el Rateret del Culebrón-Xinorlet 2018

*/

#include <hmg.ch>


#command COMPRESS [ FILES ] <afiles> ;
		TO <zipfile>  ;
		BLOCK <block> ;
		[ RESULT [ TO ] <lSuccess> ] ;
		[ LEVEL <level> ] ;
		[ <ovr: OVERWRITE> ] ;
		[ PASSWORD <password> ] ;
		[ <srp: STOREPATH> ] ;
		[ FILEPROGRESS <fileblock> ] ;
	=> ;
	[ <lSuccess> := ] hb_ZipFile( <zipfile> , <afiles> , <level> , <block> , <.ovr.> , <password> , <.srp.> , , <fileblock> )

#command UNCOMPRESS [ FILE ] <zipfile> ;
		[ EXTRACTPATH <extractpath> ] ;
		[ RESULT [ TO ] <lSuccess> ] ;
		[ BLOCK <block> ] ;
		[ <createdir: CREATEDIR> ] ;
		[ PASSWORD <password> ] ;
		[ <dummy1: FILEMASK, FILEARRAY> <mask> ] ;
		[ FILEPROGRESS <fileblock> ] ;
	=> ;
	[ <lSuccess> := ] hb_UnZipFile( <zipfile> , <block> , <.createdir.> , <password> , <extractpath> , <mask> , <fileblock> )



DEFINE WINDOW Form_1    

*------------------------------------------------------------------------------*
FUNCTION Zip_Free()
*------------------------------------------------------------------------------*

  PRIVATE aDir1W  :=  HB_Curdrive()+":\"+Rtrim(Curdir() ) 
  PRIVATE DirXY   := "Screenshot_Zip\" 
  PRIVATE DirZY   := "UnScreenshot_Zip\" 

  PRIVATE cFileD , aDir , cPath  , ficXq  , aFiles 
  PRIVATE nLen   , Typo , firaax , NuevoT
  PRIVATE FDIA   , FDIAx ,HORA   , HORAx  ,HORYx , HORy 
  PRIVATE Date_Copy  , Nome_Zip , AdireQ   
  PRIVATE nDirElemNo , aChecboQ  
  PRIVATE FicherA , Nuevo , mtable , passy , cCPass   
*-----------------------------------------------------------------*
 rNum := "0000000000"   
*-----------------------------------------------------------------*
 IF ! HB_DirExists( DirXY)
     DirMake( DirXY )
 ENDIF 
*-----------------------------------------------------------------*
 IF ! HB_DirExists( DirZY)
     DirMake( DirZY )
 ENDIF 
*-----------------------------------------------------------------*    

If !IsWIndowActive (Form_1P)
 
  DEFINE WINDOW Form_1P            ;
	AT 0, 0                    ;
	WIDTH 465 HEIGHT 415       ; 
	TITLE "Zip_Free"           ;
	ICON "Logo"                ;   
	CHILD NOMAXIMIZE NOSIZE    ;
	FONT "Arial" SIZE 9        ;
        ON INIT Enabel_11()

        ON KEY ESCAPE ACTION ( Enabel_22() ,  Form_1P.Release )

        DrawWindowBoxRaised( "Form_1P" , 10, 10, 377, 449 )  

        DEFINE TIMER Timer_1e INTERVAL 1000  ACTION (RELEASE MEMORY)
   
        DEFINE TIMER Timer_2e ;
              INTERVAL 100 ;
              ACTION { || thisWindow.Row := 170, thisWindow.Col := 440 }  

        MiFrame( 025,020,420,44,"Frame_00e","Selection Extensions for Back-Up",{ 007 ,002 , 204}, { 240,240,240 }  )   
      
        DEFINE RADIOGROUP Radio_1e
               ROW   032
               COL   033
               OPTIONS { ' *.*',' *.jpg',' *.png',' *.bmp',' *.gif',' *.tif',' *.pdf' }     
               VALUE 1 
               WIDTH 110 
               TOOLTIP 'Selection Extensions' 
               HORIZONTAL .T.
               SPACING 058
               ONCHANGE Change_Radiuse()
        END RADIOGROUP

*--------------------------------------------------------------------------------------------------*

        MiFrame( 090,020,420,51,"Frame_01e","Selection Password",{ 007 ,002 , 204}, { 240,240,240 }  )   

         DEFINE CHECKBOX Check_1e
	        ROW    094
                COL    050
                WIDTH  080  
                HEIGHT 042
                CAPTION SPACE(2)+"Automatic"     
                VALUE .T.  
                FONTNAME "Arial"
                FONTSIZE 9
	        FONTBOLD .T.
	        TRANSPARENT .F.
                TOOLTIP "PassWord"
                ONCHANGE Num_Pasworde()        
         END CHECKBOX

         DEFINE TEXTBOX Text_2e
               ROW    103 
               COL    326
               WIDTH  082
               HEIGHT 022
               FONTNAME "Arial"
               FONTSIZE 9
               TOOLTIP ""
               ONCHANGE nPassManualye()
               ONGOTFOCUS Nil
               ONLOSTFOCUS Nil
               FONTBOLD .F.
               FONTITALIC .F.
               FONTUNDERLINE .F.
               FONTSTRIKEOUT .F.
               ONENTER Nil
               HELPID Nil
               TABSTOP .T.
               VISIBLE .T.
               READONLY .T.
               RIGHTALIGN .F.
               DISABLEDBACKCOLOR  { 218,254,218 } 
               DISABLEDFONTCOLOR  { 000,000,000 } 
               BACKCOLOR  { 218,254,218 } 
               FONTCOLOR  { 000,000,000 } 
               FORMAT  Nil
               INPUTMASK "9999999999"
               VALUE  ALLTRIM( rNum  )  
               MAXLENGTH 10                  
               UPPERCASE .F. 
               LOWERCASE .T. 
         END TEXTBOX

         DEFINE LABEL Lab_002e    
                ROW    106
		COL    143
		WIDTH  167   
		HEIGHT 020  
		VALUE  "Password  For -> Un_Zip: "     
		FONTNAME "Arial"
		FONTSIZE 10
		TOOLTIP ""
		FONTBOLD .T.
	 END LABEL

*-------------------------------------------------------------------------------*

 	 DEFINE BUTTON Button_1e
		ROW    255
		COL    050
		WIDTH  150
		HEIGHT 032
		CAPTION  SPACE(04)-"&Create Backup"
		ACTION Initius_CreateZipe()   
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Create Backup"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Acep1.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

	 DEFINE BUTTON Button_2e
		ROW    255
		COL    263
		WIDTH  150
		HEIGHT 032
		CAPTION  SPACE(02)-"&Recover Backup"
		ACTION  Initius_CreateUnZipe()      
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Recover Backup"
                FONTBOLD .T.
                FONTITALIC .T.   
                PICTURE "Resource\Acep2.bmp"     
                PICTALIGNMENT  LEFT
	 END BUTTON

	 DEFINE BUTTON Button_3e
		ROW    305
		COL    050
		WIDTH  150
		HEIGHT 032
		CAPTION  SPACE(05)-"&View Zip"
		ACTION  ViewFacty()        
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "View Zip"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Viewx0.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

	 DEFINE BUTTON Button_4e
		ROW    305
		COL    263
		WIDTH  150
		HEIGHT 032
		CAPTION SPACE(09)-"&Exit"
		ACTION ( Enabel_22() ,  Form_1P.Release )  
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Exit"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Exit.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

         DEFINE LABEL Titlee    // View ProgressBar
                ROW    169  
		COL    190  
		WIDTH  225  
		HEIGHT 020
		VALUE ""
		FONTNAME "Arial"
		FONTSIZE 10
		TOOLTIP ""
		FONTBOLD .T.
		TRANSPARENT .T.
		CENTERALIGN .F.
	 END LABEL

	 DEFINE PROGRESSBAR ProgressBar_1e
		ROW    193
		COL    050
		WIDTH  368   
		HEIGHT 022   
		RANGEMIN 0   
		RANGEMAX 100  
		VALUE 0
		FORECOLOR {000,130,000}
	 END PROGRESSBAR

	 DEFINE LABEL Label_1e
		ROW    223  
		COL    055 
		WIDTH  350
		HEIGHT 020
		VALUE ""
		FONTNAME "Arial"
		FONTSIZE 10
		TOOLTIP ""
		FONTBOLD .T.
		TRANSPARENT .T.
		CENTERALIGN .T.
	 END LABEL

         SETWINDOWCURSOR ( Form_1P.Button_4e.Handle, "Resource\SmoothHand.cur")  
 
  END WINDOW

  Chane_Stylee() 
 
  Form_1P.Check_1e.Value := .F.

  CENTER WINDOW Form_1P   
  ACTIVATE WINDOW Form_1P  
 
ELSE
   Form_1P.SetFocus
ENDIF



RETURN NIL

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*-------------------------------------------------------------------------------------------* 
 FUNCTION Enabel_11()  
*-------------------------------------------------------------------------------------------*
Form_1.test_1.Enabled  := .F.
Form_1.test_2.Enabled  := .F.
Form_1.test_3.Enabled  := .F.
Form_1.test_4.Enabled  := .F.
Form_1.test_5.Enabled  := .F.
Form_1.test_6.Enabled  := .F.
Form_1.test_7.Enabled  := .F.     // Opcional --> SETPROPERTY( "Form_1","test_7","Enabled",.F.)
Form_1.test_8.Enabled  := .F. 
Form_1.test_9.Enabled  := .F. 
Form_1.test_10.Enabled := .F. 

RETURN NIL
*-------------------------------------------------------------------------------------------* 
 FUNCTION Enabel_22()  
*-------------------------------------------------------------------------------------------*
Form_1.test_1.Enabled  := .T.
Form_1.test_2.Enabled  := .T.
Form_1.test_3.Enabled  := .T.
Form_1.test_4.Enabled  := .T.
Form_1.test_5.Enabled  := .T.
Form_1.test_6.Enabled  := .T.
Form_1.test_7.Enabled  := .T. 
Form_1.test_8.Enabled  := .T. 
Form_1.test_9.Enabled  := .T. 
Form_1.test_10.Enabled := .T. 

RETURN NIL
*-------------------------------------------------------------------------------------------* 
 FUNCTION Chane_Stylee()  
*-------------------------------------------------------------------------------------------* 
 
  HMG_ChangeWindowStyle ( GetControlHandle("ProgressBar_1e","Form_1P"), LVS_REPORT, NIL, .T. )

RETURN NIL

*-------------------------------------------------------------------------------------------*
 FUNCTION   Num_Pasworde()
*-------------------------------------------------------------------------------------------*

   Form_1P.Text_2e.ReadOnly := .T.
   Form_1P.Check_1e.CAPTION := SPACE(2)+"Automatic" 
 
    aChecboQ  := ( IIF(Form_1P.Check_1e.Value,"True","False") )
 
    IF aChecboQ = "True"  
      IF  mirgy ==  "0"
          rNum  := pQrix 
          Form_1P.Text_2e.Value := ALLTRIM( rNum  )  
          Form_1P.Check_1e.CAPTION := SPACE(2) + "Automatic" 
          Form_1P.Text_2e.ReadOnly := .T.
          Form_1P.Text_2e.Value := ALLTRIM( rNum  )   
     ELSE
         rNum  := ALLTRIM( pRova )                 
         Form_1P.Text_2e.Value := ALLTRIM( rNum  )  
     ENDIF
    ELSE
      rNum := "0000000000"  
      Form_1P.Check_1e.CAPTION := SPACE(2)+"Manually "
      Form_1P.Text_2e.ReadOnly := .F.
      Form_1P.Text_2e.Value := ALLTRIM( rNum  )  
      nPassManualye()
  ENDIF

  hb_gcAll()

RETURN NIL

*------------------------------------------------------------------------------*
Function  nPassManualye()
*------------------------------------------------------------------------------*
  rNum  :=  Form_1P.Text_2e.Value 

RETURN NIL

*----------------------------------*
FUNCTION Change_Radiuse()
*----------------------------------*

DO CASE 

CASE Form_1P.Radio_1e.Value == 0
     Tipx := "*.*"
CASE Form_1P.Radio_1e.Value == 1
     Tipx := "*.*"
CASE Form_1P.Radio_1e.Value == 2
     Tipx := "*.jpg"
CASE Form_1P.Radio_1e.Value == 3
     Tipx := "*.png" 
CASE Form_1P.Radio_1e.Value == 4
     Tipx := "*.bmp"         
CASE Form_1P.Radio_1e.Value == 5
     Tipx := "*.gif"    
CASE Form_1P.Radio_1e.Value == 6
     Tipx := "*.tif"  
CASE Form_1P.Radio_1e.Value == 7
     Tipx := "*.pdf"  
  
ENDCASE

RETURN NIL

*------------------------------------------------------------------------------*
Function Initius_CreateZipe()
*------------------------------------------------------------------------------*

 PRIVATE nX

 Form_1P.Titlee.Value   := " " 
 Form_1P.Label_1e.Value := " " 

 CreateZipe() 
   
 For nX := 0 to 100 step 1

    DO EVENTS 

    Form_1P.Titlee.Value := "Progress: " + Str(nX,3)+" %"
    Form_1P.ProgressBar_1e.Value := nX    
    Form_1P.ProgressBar_1e.Refresh()   

    MILLISEC(80)   
 
 Next  
 
   MILLISEC( .08) 

   MODIFY CONTROL Label_1e OF Form_1P    FONTCOLOR {000,000,255}

   Form_1P.ProgressBar_1e.Value := 0
   Form_1P.Titlee.Value := " "
   Form_1P.Label_1e.Value := 'Backup is finished'

   Form_1P.Radio_1e.Value := 1
   Form_1P.Check_1e.Value := .F.
   Form_1P.Text_2e.Value  := "0000000000"

   RELEASE MEMORY

Return(.T.)

*------------------------------------------------------------------------------*
Function CreateZipe()
*------------------------------------------------------------------------------*

 PRIVATE cFileD := GetFolder () 
 PRIVATE aDir   := Directory( cFileD +"\"+ Tipx , "D"   ) 
 PRIVATE cPath  := cFileD +"\" 
 PRIVATE ficXq  := RIGHT( cFileD , LEN(cFileD) - RAT("\", cFileD ))  
 PRIVATE aFiles := {}
 PRIVATE Date_Copy         
 PRIVATE Nome_Zip   

  IF FILE('ZCounter.mem')
          RESTORE FROM 'ZCounter.mem' ADDITIVE 
          ZcoUn = ZcoUn + 1   
          SAVE ALL LIKE ZcoUn* TO 'ZCounter.mem' 
   ELSE 
          RESTORE FROM 'ZCounter.mem' ADDITIVE 
       IF ZcoUn = 0
          ZcoUn = ZcoUn + 1   
          SAVE ALL LIKE ZcoUn* TO 'ZCounter.mem' 
       ENDIF
  ENDIF
          RESTORE FROM 'ZCounter.mem' ADDITIVE    

*-----------------------------------------------------------------------------------------------------*
PRIVATE HORY      :=  STRZERO(ZcoUn,4)    
PRIVATE DIAX      :=  Ltrim(str(day(date())))+"-"+Ltrim(str(month(date())))+"-"+Ltrim(str(year(date())))
PRIVATE Date_Copy := "File_Backup"+"_"+alltrim(DIAX)+"-"+alltrim(HORY)+".zip"
*-----------------------------------------------------------------------------------------------------*
*------------------------------------------------------------------------------------------------------*

  IF Empty(cFileD )
    	msginfo("Please select Source Folder", "Attenttion !!!")
        MODIFY CONTROL Label_1e OF Form_1P    FONTCOLOR {000,000,255}
        Form_1P.ProgressBar_1e.Value := 0
        Form_1P.Titlee.Value := " "
        Form_1P.Label_1e.Value := 'Backup is finished'
        ZcoUn = ZcoUn - 1   
        SAVE ALL LIKE ZcoUn* TO 'ZCounter.mem' 
       	Return nil
 ENDIF 
   
 FillFiles( aFiles, aDir, cPath )

 IF ( nLen := Len(aFiles) ) > 0

         MODIFY CONTROL Label_1e OF Form_1P    FONTCOLOR {000,000,000}

   IF  rNum  <> "0000000000"

       	COMPRESS aFiles ;
	       	TO 'Screenshot_Zip\'+ Date_Copy;
		BLOCK {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } ;
		LEVEL 9 ;
		PASSWORD ALLTRIM( rNum ) ;
		OVERWRITE ;
		RESULT lSuccess
    ELSE
          COMPRESS aFiles ;
 		TO 'Screenshot_Zip\'+ Date_Copy;
                 BLOCK  {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } ;    
                 OVERWRITE
   ENDIF
*------------------------------- Back_Up Control.Dbf -------------------------*    
    CLOSE DATABASES

    DirChange( aDir1W )  

      CLOSE DATABASES
      SELECT 1  
      USE Check
      APPEND BLANK
      REPLACE ZIP_MAIL  WITH ALLTRIM(Date_Copy)   
      REPLACE RECEIVER  WITH "No Receiver Mail"
   IF rNum <> "0000000000"  
      REPLACE PASS_MAIL  WITH ALLTRIM( rNum )
   ELSE
      REPLACE PASS_MAIL  WITH "NoPassFree" 
   ENDIF
      REPLACE DATE   WITH DATE()
      REPLACE TIME   WITH TIME()
 ENDIF


RETURN NIL

*------------------------------------------------------------------------------*
Function Initius_CreateUnZipe()
*------------------------------------------------------------------------------*
 PRIVATE nQ

 Form_1P.Titlee.Value   := " " 
 Form_1P.Label_1e.Value := " " 

 CreateUnZipe()

 For nQ  := 0 to 100 step 1

    DO EVENTS 

    Form_1P.Titlee.Value := "Progress: " + Str(nQ,3)+" %"
    Form_1P.ProgressBar_1e.Value := nQ     
    Form_1P.ProgressBar_1e.Refresh()   

    MILLISEC(80)   
 
 Next  
 
   MILLISEC( .08) 
  
   MODIFY CONTROL Label_1e OF Form_1P    FONTCOLOR {000,000,255}
   Form_1P.ProgressBar_1e.Value := 0
   Form_1P.Titlee.Value := " "
   Form_1P.Label_1e.Value := 'Backup is finished'
   Form_1P.Radio_1e.Value := 1

   Form_1P.Radio_1e.Value := 1
   Form_1P.Check_1e.Value := .F.
   Form_1P.Text_2e.Value  := "0000000000"

   RELEASE MEMORY

Return(.T.)

*------------------------------------------------------------------------------*
Function  CreateUnZipe()
*------------------------------------------------------------------------------*

PRIVATE cCurDir := GetCurrentFolder(), cArchive, lSuccess
cArchive := Getfile ( { {'Zip Files','*.ZIP'} } , 'Open File' , cCurDir , .F. , .T. )
FicherA  := RIGHT( cArchive , LEN(cArchive) - RAT("\", cArchive ))  

 IF ! HB_DirExists(DirZY)   //  Directorio Destino --> \UnScreenshot_Zip
      MsgStop( SPACE(4) + cDirQ + CRLF + CRLF + "Directory not Found!","Attenttion !!!" )
      DirMake( DirZY )
      Return (.T.)
 ENDIF 

 IF !Empty(cArchive)
	Form_1P.ProgressBar_1e.RangeMin := 0
	MODIFY CONTROL Label_1e OF Form_1P    FONTCOLOR {0,0,0}

     IF hb_ZipWithPassword( cArchive ) 
      *   Msginfo("PasWord Yes")
          Form_1P.Check_1e.CAPTION := SPACE(2)+"Automatic"
          Form_1P.Check_1e.Value := .T.
          DirChange( aDir1W )       
          XercaryPasse()
          Form_1P.ProgressBar_1e.RangeMax := 2
              *  Msginfo("Password Yes")
		UNCOMPRESS cArchive ;
			EXTRACTPATH cCurDir + "\UnScreenshot_Zip" ;    
			BLOCK {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } ;
			PASSWORD ALLTRIM( rNum ) ;   
			RESULT lSuccess ;
			CREATEDIR

    ELSE
       *  Msginfo("PasWord No")
          Form_1P.Check_1e.CAPTION := SPACE(2)+"Manually "
          Form_1P.Check_1e.Value := .F.
          DirChange( aDir1W )     
          XercaryPasse()

          Form_1P.ProgressBar_1e.RangeMax := Len( hb_GetFilesInZip(cArchive) ) - 1
          *     Msginfo("Password No")
		UNCOMPRESS cArchive ;
			EXTRACTPATH cCurDir + "\UnScreenshot_Zip" ;
			BLOCK {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } ;
			RESULT lSuccess ;
			CREATEDIR

    ENDIF

      MODIFY CONTROL Label_1e OF Form_1P    FONTCOLOR {0,0,255}
      Form_1P.Label_1e.Value := iif(lSuccess, 'Restoration of Backup is finished', 'Restoration Error')


 ENDIF

Return Nil

*-----------------------------------------------------------*
FUNCTION XercaryPasse()
*-----------------------------------------------------------*

      CLOSE DATABASES
      SELECT 1  
      USE Check
      LOCATE FOR ZIP_MAIL = ALLTRIM( FicherA ) 
   IF FOUND()
      Form_1P.Text_2e.Value :=  Check->PASS_MAIL
   ENDIF
   IF  Check->PASS_MAIL == "NoPassMail"
       Form_1P.Text_2e.Value := "0000000000"   
   ENDIF 
   IF passy <>  "0000000000"   
      passy :=  Form_1P.Text_2e.Value
   ENDIF  
   passy :=  Form_1P.Text_2e.Value

   cTargetFolder := "UnScreenshot_Zip"

   IF ! FOUND()
        MsgStop("The Zip file is not in Data Base","Attention !!!")   
        Form_1P.Check_1e.CAPTION  := SPACE(2)+"Manually "
        Form_1P.Check_1e.Value    := .F.
        Form_1P.Text_2e.ReadOnly  := .F.
        Form_1P.ProgressBar_1e.Value := 0 
        Return(.F.)
      IF hb_ZipWithPassword(  cArchive ) 
      * Msginfo("PasWord Yes","Manually" )
        Form_1P.Check_1e.CAPTION  := SPACE(2)+"Manually "
        Form_1P.Check_1e.Value    := .F.
        Form_1P.Text_2e.ReadOnly  := .F.
        Form_1P.ProgressBar_1e.Value := 0
        PassManualyey()
        Return
      ENDIF      
   ENDIF
  
   DirChange( aDir1W ) 

RETURN NIL

*------------------------------------------------------------------------------*
Function  PassManualyey()
*------------------------------------------------------------------------------*
* Form_1P.Text_2e.Value  := "0000000000"
  passy :=  Form_1P.Text_2e.Value 
 
RETURN NIL

*------------------------------------------------------------------------------*
Function ProgressUpdate( nPos , cFile , lShowFileName )
*------------------------------------------------------------------------------*
	Default lShowFileName := .F.
	Form_1P.Label_1e.Value := cFileNoPath( cFile )

	if lShowFileName
		INKEY(.1)
	endif

Return Nil

*------------------------------------------------------------------------------*
Function FillFiles( aFiles, cDir, cPath )
*------------------------------------------------------------------------------*
  PRIVATE aSubDir, cItem

  FOR cItem :=1 TO LEN(cDir)
    IF cDir[cItem][5] <> "D"
      AADD( aFiles, cPath+cDir[cItem][1] )
    ELSEIF cDir[cItem][1] <> "." .AND. cDir[cItem][1] <> ".."
      aSubDir := DIRECTORY( cPath+cDir[cItem][1]+"\*.*" )
      aFiles:=FillFiles( aFiles, aSubdir, cPath+cDir[cItem][1]+"\" )
    ENDIF
  NEXT

Return aFiles



*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*