﻿#include "hmg.ch"
#include "hmg_GFilatov.ch"
#include "Camely.prg"

#command UNCOMPRESS [ FILE ] <zipfile> ;
		[ EXTRACTPATH <extractpath> ] ;
		[ RESULT [ TO ] <lSuccess> ] ;
		[ BLOCK <block> ] ;
		[ <createdir: CREATEDIR> ] ;
		[ PASSWORD <password> ] ;
		[ <dummy1: FILEMASK, FILEARRAY> <mask> ] ;
		[ FILEPROGRESS <fileblock> ] ;
	=> ;
	[ <lSuccess> := ] hb_UnZipFile( <zipfile> , <block> , <.createdir.> , <password> , <extractpath> , <mask> , <fileblock> )

Function Main()

*---------------------------------------------------------------------------------------* 
 #pragma TEXTHIDDEN(1) 
    PUBLIC  cSenha := "Q65h3l8j41B"  // <- Very important not to change Password or Delete !!!                  
 #pragma TEXTHIDDEN(0) 
*---------------------------------------------------------------------------------------*
  SET ESCAPE ON
  SET DELETE ON 
  SET CENTURY ON
  SET DATE FRENCH
  SET NAVIGATION EXTENDED
  SET TOOLTIPSTYLE BALLOON
  SET CODEPAGE TO UNICODE
*---------------------------------------------------------------------------------------*
  PUBLIC  cFileD  , cContenido , fix , filax  , rNum := ""
  PRIVATE cCurDir , cArchive   , FicherA , cArchive ,FicherA 
  PRIVATE cFilex  , cRazao     , cRazaq , Nuevo , BusNom   
  PRIVATE cBuffer , nLines     , nCurrLine ,  cTemp 
  PRIVATE Fikuy   , Fikuyo     , Fikoy ,  Fikup , nNumFix 
*---------------------------------------------------------------------------------------*  
  PRIVATE DirXY   := "Decrypt_Zip" 
  PRIVATE DirXZ   := "Decrypt_Zip\Files_Picture"     
*---------------------------------------------------------------------------------------*  
  IF ! HB_DirExists( DirXY)
     DirMake( DirXY )
  ENDIF   
  IF ! HB_DirExists( DirXZ)
     DirMake( DirXZ )
  ENDIF   

  IF FILE("Decrypt_-D.txt")
     FileDelete("Decrypt_-D.txt")
  ENDIF 
*---------------------------------------------------------------------------------------*  

 DEFINE WINDOW Form_003                      ;
        At 0,0 Width 650 Height 592          ; 
        Title 'Decrypt_Tools Files Zip 2018' ;
        ICON "Logo"                          ;
        MAIN NOSIZE NOMAXIMIZE 
  
        ON KEY ESCAPE ACTION Form_003.Release  
      
        DrawWindowBoxRaised( "Form_003" , 10, 10, 500, 633 )  

        @ 028,217 LABEL Label_001 VALUE "Decrypt_Tools Files Zip" WIDTH 250 HEIGHT 029 FONT "Arial" SIZE 15 BOLD ITALIC   

        @ 064,262 LABEL Label_002 VALUE "Name of the TxT File"   WIDTH 250 HEIGHT 020 FONT "Arial" SIZE 09 BOLD ITALIC           
        @ 122,258 LABEL Label_003 VALUE "Password Numnumber "    WIDTH 250 HEIGHT 020 FONT "Arial" SIZE 09 BOLD ITALIC   
        @ 183,268 LABEL Label_004 VALUE "TxT file Information"   WIDTH 250 HEIGHT 020 FONT "Arial" SIZE 09 BOLD ITALIC   
        @ 339,262 LABEL Label_005 VALUE "Name Files Within Zip"  WIDTH 250 HEIGHT 020 FONT "Arial" SIZE 09 BOLD ITALIC   

   DEFINE TEXTBOX Tex_001 
        ROW    088
        COL    270
        WIDTH  108
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        DISABLEDBACKCOLOR  {183,214,255}   
        DISABLEDFONTCOLOR  {000,000,000} 
        READONLY .T.
        RIGHTALIGN .F.
        PASSWORD .F.                  
        BACKCOLOR { 180,200,255 }      
        FONTCOLOR Nil
        INPUTMASK NIL
        MAXLENGTH 16            
        FORMAT Nil
        VALUE ""
        LOWERCASE .F.  
        UPPERCASE .F.       
    END TEXTBOX

    DEFINE CHECKBOX Check_001
	ROW    141
        COL    169
        WIDTH  080  
        HEIGHT 042
        CAPTION SPACE(2)+"Automatic"     
        VALUE .T. 
        FONTNAME "Arial"
        FONTSIZE 9
	FONTBOLD .T.
        BACKCOLOR NIL    
        FONTCOLOR NIL 
	TRANSPARENT .F.
        TOOLTIP "PassWord"
        ONCHANGE Num_Pasword()        
    END CHECKBOX

    DEFINE TEXTBOX Tex_002 
        ROW    148
        COL    270
        WIDTH  109
        HEIGHT 023
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER NIL  
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        DISABLEDBACKCOLOR  {183,214,255}   
        DISABLEDFONTCOLOR  {000,000,000} 
        READONLY .T.  
        RIGHTALIGN .F.
        PASSWORD .F.                  
        BACKCOLOR { 180,200,255 }      
        FONTCOLOR Nil
        INPUTMASK "9999999999"
        MAXLENGTH 10            
        FORMAT Nil
        VALUE "0000000000"
        LOWERCASE .F.  
        UPPERCASE .F.       
    END TEXTBOX

    DEFINE EDITBOX Edit_001
        ROW    212                       
        COL    206              
        WIDTH  235     
        HEIGHT 118  
        VALUE cContenido
        FONTNAME 'Courier New'
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        DISABLEDBACKCOLOR  {183,214,255}   
        DISABLEDFONTCOLOR  {000,000,000} 
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        HSCROLLBAR .F.
        VSCROLLBAR .F.
        BACKCOLOR {183,214,255}        
        FONTCOLOR Nil
    END EDITBOX

    DEFINE LISTBOX List_002
        ROW    368 
        COL    206
        WIDTH  235
        HEIGHT 118
        ITEMS {""}
        VALUE 0
        FONTNAME "Arial"
        FONTSIZE 10
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F. 
        BACKCOLOR { 254,255,116 }  
        FONTCOLOR Nil
        VISIBLE .T.
        ONDBLCLICK NIL          
        MULTISELECT .T.	
    END LISTBOX     

*-----------------------------------------------------------------------------*

    DEFINE BUTTON But_001
         ROW    517  
         COL    050  
         WIDTH  119
         HEIGHT 036
         ACTION ( xButVisible_NO() , Decrypt() )     
         CAPTION SPACE(02)-"Decrypt_TxT"
         PICTURE "Resource\Acep1.bmp"
         PICTALIGNMENT LEFT 
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         TOOLTIP  "Decrypt_TxT" 
    END BUTTON
   
    DEFINE BUTTON But_002
         ROW    517  
         COL    194 
         WIDTH  119 
         HEIGHT 036
         ACTION (  xButVisible_SI() , SalvaFichero()  )    
         CAPTION SPACE(02)-"Decrypt_Zip"
         PICTURE "Resource\Acep2.bmp"
         PICTALIGNMENT LEFT 
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         TOOLTIP "Decrypt_Zip" 
    END BUTTON
  
    DEFINE BUTTON Button_003
        ROW    517 
        COL    334 
        WIDTH  119 
        HEIGHT 036
        CAPTION SPACE(06)-"C&lean"
        ACTION  Limpiare()   
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Clean"
        FONTBOLD .T.
        FONTITALIC .T.
        PICTURE "Resource\Clean.bmp"
        PICTALIGNMENT LEFT
    END BUTTON

    DEFINE BUTTON But_004
         ROW    517  
         COL    473 
         WIDTH  119  
         HEIGHT 036
         ACTION  ( Eixida() ,  Form_003.Release )
         CAPTION SPACE(07)-"Exit"         
         PICTURE "Resource\Cancel.bmp"
         PICTALIGNMENT LEFT 
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         TOOLTIP "Exit"
    END BUTTON

  End Window

    Chane_StyleN()    
  
    SETWINDOWCURSOR (Form_003.But_004.Handle , "Resource\SmoothHand.cur")    

    Form_003.But_001.Enabled := .T.
    Form_003.But_002.Enabled := .F.        

 Form_003.Center
 Form_003.Activate

Return Nil

*---------------------------------------------------------*
 FUNCTION   Num_Pasword()
*---------------------------------------------------------*

          Form_003.Tex_002.ReadOnly  := .T.
          Form_003.Check_001.CAPTION := SPACE(2)+"Automatic" 
 
     aChecboQ  := ( IIF(Form_003.Check_001.Value,"True","False") )
 
    IF aChecboQ = "True"  
          xButVisible_NO()
          Form_003.Tex_002.Value     := ALLTRIM( rNum  )  
          Form_003.Check_001.CAPTION := SPACE(2)+"Automatic" 
          Form_003.Tex_002.ReadOnly  := .T.
          Form_003.Tex_002.Value     := ALLTRIM( rNum  )   
    ELSE
          xButVisible_SI()
          rNum := "0000000000"  
          Form_003.Check_001.CAPTION := SPACE(2)+"Manually "
          Form_003.Edit_001.Value    := ""
          Form_003.List_002.DeleteAllItems() 
          Form_003.Tex_002.ReadOnly  := .F.
          Form_003.Tex_002.Value     := ALLTRIM( rNum  )  
  ENDIF

  hb_gcAll()

RETURN NIL

*---------------------------------------------------------*
FUNCTION Eixida()       
*---------------------------------------------------------*
       
    IF MsgYesNo( "Proceed to Remove the File ?"+CRLF+CRLF+;
                 "Password ->Decrypt"  , "Delete File!!!")
       Borrado := "Decrypt_Zip\*D.txt"
       FileDelete( Borrado )
   ENDIF

Return

*---------------------------------------------------------*
FUNCTION Limpiare()
*---------------------------------------------------------*
  Form_003.Tex_001.Value := ""
  Form_003.Tex_002.Value := "0000000000"
  Form_003.Edit_001.Value := ""
  Form_003.List_002.DeleteAllItems() 
  Form_003.But_001.PICTURE := "Resource\Acep1.bmp"
  Form_003.But_002.PICTURE := "Resource\Acep2.bmp"
  Form_003.But_001.Enabled := .T.
  Form_003.But_002.Enabled := .F.
  Form_003.But_001.PICTURE := "Resource\Acep1.bmp"
  Form_003.But_002.PICTURE := "Resource\Acep2.bmp" 
  Form_003.Check_001.Value := .T.
Return 

*---------------------------------------------------------*
FUNCTION xButVisible_NO()
*---------------------------------------------------------*
  Form_003.But_001.PICTURE := "Resource\Acep1.bmp"     
  Form_003.But_002.PICTURE := "Resource\Acep2.bmp"
  Form_003.But_001.Enabled := .T.
  Form_003.But_002.Enabled := .F.
  Form_003.But_001.PICTURE := "Resource\Acep1.bmp"     
  Form_003.But_002.PICTURE := "Resource\Acep2.bmp"
Return

*---------------------------------------------------------*
FUNCTION xButVisible_SI()
*---------------------------------------------------------*
  Form_003.But_001.PICTURE := "Resource\Acep2.bmp"
  Form_003.But_002.PICTURE := "Resource\Acep1.bmp"
  Form_003.But_001.Enabled := .F.
  Form_003.But_002.Enabled := .T.
  Form_003.But_001.PICTURE := "Resource\Acep2.bmp"
  Form_003.But_002.PICTURE := "Resource\Acep1.bmp"
Return

*---------------------------------------------------------* 
 FUNCTION Chane_StyleN()   
*---------------------------------------------------------* 
 HMG_ChangeWindowStyle ( GetControlHandle("Edit_001","Form_003"), LVS_REPORT, NIL, .T. )
 HMG_ChangeWindowStyle ( GetControlHandle("List_002","Form_003"), LVS_REPORT, NIL, .T. )
Return   

*---------------------------------------------------------*
 FUNCTION  SalvaFichero()                     
*---------------------------------------------------------*

    nNumFix   :=  ALLTRIM( Form_003.Tex_002.Value)  
 
   IF nNumFix <= space(1) 
      MsgStop("Falta Número Password", "Atención !!!")
      Return
   ENDIF

          SAVE ALL LIKE  nNumFix* TO 'ZnNumFix.mem' 
          RESTORE FROM 'ZnNumFix.mem' ADDITIVE    
  
   CreateUnZipe()

Return  Nil 

*---------------------------------------------------------*
Function  CreateUnZipe()
*---------------------------------------------------------*
 PRIVATE cCurDir  := GetCurrentFolder() +"\Decrypt_Zip\" , cArchive, lSuccess   
 cArchive := Getfile ( { {'Zip Files','*.ZIP'} } , 'Open File' , cCurDir , .F. , .T. )
 FicherA  := RIGHT( cArchive , LEN(cArchive) - RAT("\", cArchive )) 

 FillDirListZ()

 IF !Empty(cArchive)

   RESTORE FROM 'ZnNumFix.mem' ADDITIVE    
   rNum :=  nNumFix     

		UNCOMPRESS cArchive ;
			EXTRACTPATH cCurDir + "Files_Picture" ;      
			BLOCK {|| NIL}	          ;             
			PASSWORD ALLTRIM( rNum ) 

 ENDIF

 xButVisible_NO()
 Form_003.Tex_002.Value   := "0000000000" 
 Form_003.Check_001.Value := .T.
Return Nil

*---------------------------------------------------------*
FUNCTION FillDirListZ()
*---------------------------------------------------------*
 PRIVATE i:= 0 ,  aFiles 

 Form_003.List_002.DeleteAllItems() 
 aFiles := hb_GetFilesInZip( cArchive )  

  FOR i := 1 TO LEN( aFiles )
      Form_003.List_002.AddItem( aFiles [ i ] , 1 ) 
  NEXT i

Return 

*---------------------------------------------------------*
FUNCTION Decrypt()       
*---------------------------------------------------------*
   Form_003.Tex_001.Value  := ""
   Form_003.Edit_001.Value := ""
   Form_003.List_002.DeleteAllItems() 

   cCurDir := "Decrypt_Zip\" 
   cArchive := Getfile ( { {'TxT Files','*.txt'} } , 'Open File' , cCurDir , .F. , .T. )  
   FicherA  := RIGHT( cArchive , LEN(cArchive) - RAT("\", cArchive ))  

   Fikuy  := LEFT (  FicherA , LEN(FicherA ) - 4 ) + "-D.txt"
   Fikup  := LEFT (  FicherA , LEN(FicherA ) - 4 ) + ".txt"
   Fikuyo := RIGHT(  Fikuy ,5) 
   Fikoy  := RIGHT(  FicherA ,5)

   IF ALLTRIM(Fikoy) == ALLTRIM( Fikuyo ) 
      MsgStop("El Fichero: " + SPACE(3)+ Fikup + CRLF +CRLF +;
              "Tiene que ser Sin Extensión -> D.txt","Attention!!!" )  
              Form_003.Edit_001.value := " "
        RETURN(.F.)
   ENDIF

   BusNom := ALLTRIM( LOWER( FicherA) )  
   Form_003.Tex_001.Value := CamelCase( BusNom ,.T.,{"_","/","\"})

   cFilex :=  cCurDir + FicherA
   cRazao :=  HB_MEMOREAD( cFilex )   
   cRazaq :=  HB_DECRYPT( cRazao, cSenha ) 
   Nuevo  :=  LEFT ( cFilex , LEN( cFilex ) - 4 ) + "-D.txt"
   HB_MEMOWRIT( Nuevo, cRazaq ) 
  
   cFileD := Nuevo  
   cContenido := HB_MEMOREAD( cFileD )

   Form_003.Edit_001.value := cContenido

*------------ Encontrar número Password en Txt  ----------------*
   cBuffer := cContenido                
   nLines  := MLCOUNT( cBuffer , 40 ) 
   nLines  := 6
   FOR nCurrLine = 6 TO nLines
       cTemp := MEMOLINE( cBuffer , 40 , nCurrLine)   
   NEXT
   nNumFix := ALLTRIM(cTemp )

   SAVE ALL LIKE  nNumFix* TO 'ZnNumFix.mem' 
   RESTORE FROM 'ZnNumFix.mem' ADDITIVE    
*--------------------------------------------------------------*
   Form_003.Tex_002.Value := nNumFix  
   Form_003.Check_001.Value := .T.

   IF FILE("Decrypt_-D.txt")
      FileDelete("Decrypt_-D.txt")
   ENDIF 

   xButVisible_SI()

Return nil

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*


